//Razvan Bocu, gr. 7211
//Tema 4
//Problema 2

import java.io.*;

//Clasa modeleaza comportamentul polinoamelor
//cu coeficienti reali de orice grad
//Operatii implementate:
//	-suma a doua polinoame
//	-produsul a doua polinoame
//	-inmultirea unui polinom cu un scalar
//	-catul a doua polinoame

//Clasa main contine cate un exemplu
//de utilizare pentru fiecare operatie implementata.
//(nu sunt identice cu exemplificarile propuse la curs!!!)

class polinom
{
	private
	 int grad;
	 double[] coef;
	 
	public
	
    //Constructorul clasei
    //  -Seteaza gradul polinomului
    //  -Aloca memorie pentru pastrarea coeficientilor
    //  -Initializeaza coeficientii cu zero
	
	polinom(int n)
	{
		grad=n;
		coef=new double[grad+1];
		for(int i=0;i<=grad;i++)
		  coef[i]=0;
    }
    
    //Metoda publica pentru setarea 
    //gradului polinomului
    
    void setgrad(int g)
    {
    	grad=g;
	}
     
    //Metoda publica pentru consultarea
    //gradului polinomului 
    
    int getgrad()
    {
    	return grad;
    }
     
    //Metoda publica pentru setarea 
    //indexata a valorilor coeficientilor 
    //In caz de index eronat se semnaleaza exceptia
    //si executia este continuata
    //pe riscul utilizatorului
    
    void setcoef(int i,double c)
    {
    	try
    	{
    	  coef[i]=c;
        }
    	catch(Exception e)
        {
           System.out.println("Eroare la setare: "+e);
        }
    }
    
    //Metoda publica pentru consultarea indexata
    //a coeficientilor
    //In caz de index eronat se semnaleaza exceptia
    //si executia este continuata
    //pe riscul utilizatorului
    
    double getcoef(int i)
    {
    	try
    	{
    	  return coef[i];
        }
    	catch(Exception e)
    	{
    	  System.out.println("Eroare la consultare: "+e);
    	  return 0;
        }
	}
	
	
	//Metoda publica pentru efectuarea sumei 
	//a doua polinoame
	//Un polinom este trimis metodei ca obiect context de
	//apel al metodei
	//Al doilea polinom este trimis ca parametru
	//Metoda returneaza un obiect polinom
    
    polinom sumap(polinom pol)
    {
      int q=0;
      int p=0;
      
      //Alocare polinom tampon
      polinom tamp=new polinom(Math.max(this.grad,pol.grad));
      if(this.grad<pol.grad)
      {
        q=this.grad;
        p=pol.grad;
      }
      else
      {
      	q=pol.grad;
      	p=this.grad;
      };
      for(int i=0;i<=q;i++)         
      	tamp.coef[i]=this.coef[i]+pol.coef[i];
      if(p<q)
        for(int i=q+1;i<=pol.grad;i++)
          tamp.coef[i]=pol.coef[i];
      else
        for(int i=q+1;i<=this.grad;i++)
          tamp.coef[i]=this.coef[i];
      while(tamp.coef[p]==0)
        p=p-1;
        tamp.grad=p;
      return tamp;
    }
  
    //Metoda publica pentru efectuarea produsului 
	//a doua polinoame
	//Un polinom este trimis metodei ca obiect context de
	//apel al metodei
	//Al doilea polinom este trimis ca parametru
	//Metoda returneaza un obiect polinom
    
    polinom prodpol(polinom pol)
    {
      int grad=this.grad+pol.grad;
      polinom tamp=new polinom(grad);
      polinom op1=new polinom(grad);
      polinom op2=new polinom(grad);
      for(int i=0;i<=this.grad;i++)
      {  
        op1.setcoef(i,this.coef[i]);
      }
     
      for(int i=0;i<=pol.grad;i++)
      {
        op2.setcoef(i,pol.coef[i]); 
      }
      for(int k=0;k<=grad;k++)
        for(int i=0;i<=k;i++)
        { 
          tamp.coef[k]=tamp.coef[k]+op1.coef[i]*op2.coef[k-i];     
        }
      return tamp;
    }
  
    
    private
    
    //Metoda privata care efectueaza
    //aducerea unui polinom la gradul gr
    //si inmultirea lui cu un scalar 
    //p1 este polinomul care face 
    //obiectul inmultirii 
    
    void mulps(polinom p1,int gr,double scalar,polinom p2)
    {
      for(int k=0;k<gr+1;k++)
  	  if(k<(p1.getgrad()+1))
  	  {
  	    p2.setcoef(k,p1.getcoef(k)*scalar);
  	  }
  	  else
  	  {
  	   p2.setcoef(k,0);
  	  } 
  	 p2.setgrad(gr);
    }  
  
    //Metoda privata care efectueaza 
    //adunarea a doua polinoame de 
    //acelasi grad
    //	-p1 este primul termen al sumei
    //	-p2 este al doilea termen al sumei
    //	-p3 este polinomul suma
    
    void add2pol(polinom p1,polinom p2,polinom p3)
    {

      int decg=0;
      p3.setgrad(p1.getgrad());
      for(int k=0;k<(p1.getgrad()+1);k++)
        p3.setcoef(k,(p1.getcoef(k)+p2.getcoef(k)));
      do
      {
    	decg++;
    	if(p3.getcoef(0)==0)
    	 for(int k=0;k<p1.getgrad();k++)
    	   p3.setcoef(k,p3.getcoef(k+1));
      }
      while((p3.getcoef(0)==0)&&(decg<p1.getgrad()));
        p3.setgrad(p3.getgrad()-decg);
        
    }
    
    public
    
    //Metoda publica care efectueaza 
    //impartirea a doua polinoame
    //	-polinomul deaimpartit se vede prin intermediul
    //	variabilei obiect context
    //	-im este polinomul impartitor
    //	-cat este polinomul cat
    //	-res este polinomul rest
    
    void imp(polinom im,polinom cat,polinom res)
    {
   	  if(this.getgrad()<im.getgrad())
  	  {
  		cat.setgrad(0);
  		res=im;
      }
      else
      {
        if (im.getgrad()==0)
        {
        	System.out.println("Polinomul impartitor are gradul 0...");
        }
        else
        {
          polinom detam=new polinom(this.getgrad());
          polinom paux=new polinom(this.getgrad());
          polinom pprod=new polinom(this.getgrad());
          for(int i=0;i<=this.grad;i++)
           detam.setcoef(i,this.getcoef(i));
          detam.setgrad(this.getgrad());       
          int i=-1;
          int gdc;
          gdc=detam.getgrad();    	  
          do
          {
    	    i++;
    	    cat.setcoef(i,detam.getcoef(0)/im.getcoef(0));
    	    mulps(im,detam.getgrad(),(-detam.getcoef(0)/im.getcoef(0)),paux);
 
     	    add2pol(detam,paux,pprod);
    	    
    	    while((detam.getgrad()-pprod.getgrad())>1)
    	    {
    		  i++;
    		  cat.setcoef(i,0);
    		  gdc--;
            }
          
            gdc=pprod.getgrad();
            for(int j=0;j<=pprod.getgrad();j++)
            detam.setcoef(j,pprod.getcoef(j));
            detam.setgrad(pprod.getgrad());           
          
          }
          while(gdc>=im.getgrad());     
          cat.setgrad(this.getgrad()-im.getgrad());
          res.setgrad(pprod.getgrad());
          for(int j=0;j<=pprod.getgrad();j++)
            res.setcoef(j,pprod.getcoef(j));
        }
      }
    } 

    //Metoda publica pentru
    //afisare simpla coeficienti polinom
    
    void afis()
    {
  	  for(int i=0;i<=grad;i++)
  	     System.out.println(coef[i]);
  	}; 

}

//Clasa exemplu de utilizare a clasei polinom  

public class prob_2
{
	public static void main(String[] args)
	{
		int dim=3;
		polinom x=new polinom(dim);
		polinom y=new polinom(dim);
		polinom x1=new polinom(10);
		polinom s=new polinom(dim);
		polinom p=new polinom(2*dim);
		for(int i=0;i<=dim;i++)
		{
			x.setcoef(i,(double)(i+1));
		}
		for(int i=0;i<=dim;i++)
		{
			y.setcoef(i,(double)((i+1)*(i+1)));
		}       	      	  
		
		//Testare suma polinoame
		
		s=x.sumap(y);
		x.afis();
		System.out.println("**Primul operand:");
		y.afis();
		System.out.println("**Al doilea operand:");
		System.out.println("**Suma...");
		s.afis();
	    try
	    {
	    	int ch=System.in.read();	
	    }
	 	catch(Exception e)
	 	{
	    }
	 
		System.out.println("**Produsul...");
        //Testare produs polinoame
        
        p=x.prodpol(y);
        p.afis();
        try
	    {
	    	int ch=System.in.read();	
	    	ch=System.in.read();
	    }
	 	catch(Exception e)
	 	{
	    }
        
         System.out.println("**Impartirea...");
        //Testare impartire polinoame
        
        x.setgrad(2);
        x.setcoef(0,1);
        x.setcoef(1,2);
        x.setcoef(2,1);
        y.setgrad(1);
        y.setcoef(0,1);
        y.setcoef(1,1);
        polinom cat=new polinom(10);
        polinom res=new polinom(10);
        System.out.println("Deimpartit...");
        x.afis();
        System.out.println("Impartitor...");
        y.afis();
        x.imp(y,cat,res);
        System.out.println("Cat impartire...");
        cat.afis();
        System.out.println("Rest impartire...");
        res.afis();
       }
}