//Razvan Bocu, gr. 7211
//Tema 7
//Problema 1

import java.io.*;

//Clasa abstracta ce defineste 
//o figura geometrica generica.

abstract class Shape
{
	private 
	  String nume;
	
	public  abstract double aria();
	
	public  Shape(String ShapeName)
	{
	  nume=ShapeName;
    }
    
    final public boolean lessThan(Shape rhs)
    {
      return aria()<rhs.aria();
    }
    
    final public String toString()
    {
      return nume+"ul are aria "+String.valueOf(aria());
    }
  
    public String getMes()
    {
    	return nume;
    }
}

//Clasa Cerc derivata din clasa
//abstracta si generica Shape.

class Circle extends Shape
{
	//static final private PI=3.14;
	private double radius;
	
	public Circle(double rad)
	{
		super("Cerc");
		radius=rad;
    }

public double aria()
{
	return Math.PI*radius*radius;
}
}

//Clasa Dreptunghi derivata din
//clasa Shape.

class Rectangle extends Shape
{
	    private double length;
		private double width;
		public Rectangle(double len, double wid)
		{
			super("Dreptunghi");
			length=len;
			width=wid;
	    }
	    
	 public double aria()
	 {
	 	return length*width;
	 }
}

//Clasa Patrat derivata din clasa Shape.

class Square extends Shape
{
	
	private double length;
	private double width;

	public Square(double side)
	{
	  		super("Patrat");
			length=side;
			width=side;
	    }
	    
	 public double aria()
	 {
	 	return length*width;
	 }
}

//Clasa ce testeaza metodele definite
//in Shape.

class TestShape
{
	private static BufferedReader in;
	
	public static void main(String[] args)
	{
		try
		{
			//Citeste numarul de figuri
			in=new BufferedReader(new InputStreamReader(System.in));
			System.out.println("Numarul de figuri:");
			int numShapes=Integer.parseInt(in.readLine());
			
			//Citeste formele
			
			Shape[] shapes=new Shape[numShapes];
			for(int i=0;i<numShapes;++i)
			{
				shapes[i]=readShape(i+1);
			}
			
			//Sortare si afisare
			
			//Se realizeaza sortarea dupa arie 
			//a sirului de figuri.
			
			insertionSort(shapes);
			System.out.println("Figurile sortate dupa arie sunt:");
            for(int i=0;i<numShapes;++i)
            {
            	System.out.println((i+1)+". "+shapes[i]);
            }
           }
           catch(Exception e)
           {
           	System.out.println(e);
           }
}

//Metoda statica ce citeste
//un element din sirul de figuri.

private static Shape readShape(int index)
{
	double rad;
	double len;
	double wid;
	String s;
	
	try
	{
		System.out.println("Introduceti tipul figurii "+index+"(c, p sau d):");
		do
		{
			s=in.readLine();
		}
		while(s.length()==0);
		
		switch(s.charAt(0))
		{
			case 'c':
			 System.out.println("Raza cercului:");
			 rad=Integer.parseInt(in.readLine());
			 return new Circle(rad);
			 
			case 'p':
			 System.out.println("Latura patratului:");
			 len=Integer.parseInt(in.readLine());
			 return new Square(len);
			 
			case 'd':
			 System.out.println("Lungimea si latimea dreptunghiului pe linii separate:");
			 len=Integer.parseInt(in.readLine());
			 wid=Integer.parseInt(in.readLine());
			 return new Rectangle(len,wid);
			default:
			 System.err.println("Introduceti c, p sau d!");
			 return new Circle(0);
		}
	}
	catch(IOException e)
	{
		System.err.println(e);
		return new Circle(0);
	}
}

//Se realizeaza sortarea prin insertie
//a sirului de figuri.

private static void insertionSort(Shape[] a)
{
	for(int p=1;p<a.length;++p)
	{
		Shape tmp=a[p];
		int j=p;
		for(;j>0 && tmp.lessThan(a[j-1]);--j)
		{
			a[j]=a[j-1];
		}
		a[j]=tmp;
	}
}
}   