//Razvan Bocu, gr. 7211
//Tema 7
//Problema 2

import java.io.*;
import java.util.StringTokenizer;

//Clasa abstracta ce defineste si
//implementeaza metodele
//necesare pentru Backtracking.

abstract class Backtracking
{
	int n;
	boolean as,ev;
	int[] x;
	public Backtracking(int n)
	{
		this.n=n;
		x=new int[n];
        for(int i=0;i<n;++i)
        x[i]=-1;
    }
    
    public void back()
    {
    	int k=0;
    	init(k,x);
    	while(k>=0)
    	{
    		do
    		{
    			as=succesor(k,x);
    			if(as)
    			  ev=valid(k,x);
    		}
    		while(!((!as)||(as && ev)));
    		if(as)
    		{
    			if(solutie(k))
    			 tipar(k);
    			else
    			{
    				++k;
    				init(k,x);
    			}
    		}
    		else
    		  k--;
    	}
    }
    public abstract boolean succesor(int k,int[] x);
    public abstract boolean valid(int k,int[] x);
    public abstract void tipar(int k);
    public abstract void init(int k, int[] x);
    public abstract boolean solutie(int k);
 }
 
 //Clasa Reader ce contine metodele
 //necesare pentru citirea de la tastatura.
 
 class Reader
 {
 	public static String readString()
 	{
 		BufferedReader in=new BufferedReader(new InputStreamReader(System.in));
 		try
 		{
 			return in.readLine();
 	    }
        catch(IOException e)
        {
        }
        return null;
    }
       
 	static int readInt()
 	{
 		return Integer.parseInt(readString());
 	}
 	
 	public static double readDouble()
 	{
 		return Double.parseDouble(readString());
 	}
 	
 	public static char readChar()
 	{
 		BufferedReader in=new BufferedReader(new InputStreamReader(System.in));
 		try
 		{
 			return(char)in.read();
 		}
 		catch(IOException e)
 		{
 		}
 		return'\0';
 }
 
 public static int[] readIntArray()
 {
 	String s=readString();
 	StringTokenizer st=new StringTokenizer(s);
 	int[] a=new int[st.countTokens()];

    for(int i=0;i<a.length;++i)
    {
    	a[i]=Integer.parseInt(st.nextToken());
    }
    return a;
  }
  
}

//Contine implementarea propriu zisa
//a strategiei definite in 
//clasa abstracta Backtracking.

class Plati extends Backtracking
{
	int s=180;
	
	int[] nz={1,2,1,3,1,2,1,1,1,1};
	int[] sz={30,15,30,10,30,15,45,45,45,45};
    int[] hoti={1,2,3,4,5,6,7,8,9,10}; 
    int max=-5;
    
	public boolean succesor(int k,int[] x)
	{
		if((x[k]<nz.length-1)&&((k==0)||((k>0)&&(x[k]<x[k-1]))))
		{
			x[k]++;
			return true;
		}
		else
		 return false;
    }
    
    public boolean valid(int k,int[] x)
    {
    	int i,s1=0;
        for(i=0;i<=k;i++)
        s1=s1+sz[x[i]]*nz[x[i]];
        if(s<s1)
         return false;
        else
         return true;
    }
    
    public void tipar(int k)
    {
    	boolean da=true;
    	for(int i=0;i<=k;i++)
    	for(int j=0;j<=k;j++)
    	  if(i!=j)
    	   if(hoti[x[i]]==hoti[x[j]])
    	    da=false;
    	if((da==true)&&(k>max))
    	{
    	System.out.println("SOLUTIE-suma disponibila:"+s+" lei....");
    	for(int i=0;i<=k;i++)
    	 System.out.println("Hotul "+hoti[x[i]]+" consuma "+(sz[i]*nz[i])+" lei. Zile detentie:"+nz[i]+". Suma zilnica:"+sz[i]+".");
        System.out.println();
        max=k;
        }       
    }
    
    public void init(int k,int[] x)
    {
    	x[k]=-1;
    }
    
    public boolean solutie(int k)
    {
    	int i,s1;
    	for(i=0,s1=0;i<=k;i++)
    	 s1=s1+sz[x[i]]*nz[x[i]];
    	if(s==s1)
    	 return true;
    	else
    	 return false;
    }
    
    public Plati(int n)
    {
    	super(n);
    }
    
    //Metoda main care pune la lucru
    //Backtrackingul implementat mai sus.
    
    public static void main(String[] args)
    {
        Plati plati=new Plati(10);
    	plati.back();
      System.out.println("Aceasta ultima solutie este cea mai convenabila.");
    }
}    
